####################################################
#
#	T.awk - A simple demo
#
#	usage: bmawk -f t.awk -f dxf_fns.awk t.txt > t.dxf
#
#	doug rice, (c) 2011	
#
####################################################

BEGIN {

	FS	= ","
	lastX 	= 0
	lastY 	= 0

	# set size of graph
	xl	= -6
	xr	= -1
	yt	=  6
	yb	=  0


	# Start the DXF file
	F_header()


# draw grid

        for ( x = 0 ; x < ( xr - xl ) ; x ++ ) {
	  line( xl+x,yb  ,xl+x,yt  ,9)
	}

        for ( y = 0 ; y < ( yt - yb ) ; y ++ ) {
  	  line( xl,  yb+y,xr  ,yb+y,9)
	}



# The message sets the state for the next line

        for ( x = 0 ; x < 10 ; x ++ ) {
		line( 0,x*0.5,2,x*0.5,x)
		line( 0,x*0.5+0.2,2,x*0.5+0.2,x)

		text( 2.5, x*0.5, 0,  "** "+x)
	}
}

/data/ {
	line( lastX-6,lastY,(NR / 2)-6,$2*1,1)
	text( (NR / 2)-6,$2*1, 0,  "** " (NR / 2)-6 "," $2*1)

	lastX = NR / 2
	lastY = $2*1
}

END {

# draw box

	# top and bottom
	line(xl,yb,xr,yb,0)
	line(xl,yt,xr,yt,0)

	# left and right
	line(xl,yb,xl,yt,0)
	line(xr,yb,xr,yt,0)


#	line( 0,0,100,0,0)  # black
#	line( 0,1,100,1,1)  # red
#	line( 0,2,100,2,2)  # yellow
#	line( 0,3,100,3,3)  # green 
#	line( 0,4,100,4,4)  # cyan
#	line( 0,5,100,5,5)  # blue
#	line( 0,6,100,6,6)  # magenta
#	line( 0,7,100,7,7)  # Black
#	line( 0,8,100,8,8)  # black
#	line( 0,9,100,9,9)  # black
	# And finally tidy up the DXF file
	F_end()

}
