#########################################################
#
#	Awk Functions 
#	Copyright 2002	Doug Rice 
#
#	These functions are based on dxf files ouput by deltacad 2.3
#
# 	usage: bmawk -f t.awk -f dxf_fns.awk t.txt > t.dxf
#
#
#	---------- dxf_fns.awk
#	function line(  x1, y1,  x2, y2, colour )
#	function dottedline(  x1, y1,  x2, y2, colour )
#	function point(  x1, y1,  x2, y2 )
#	function text(  x1, y1, angle, s1 )
#	function text_Centered(  x1, y1, angle, s1 )
#	function F_insert( x1,y1,name )
#
#	function F_header()	- needed once at start of Awk Script
#	function F_end ()	- needed once at start of Awk Script
#
#
#
#########################################################


function line(  x1, y1,  x2, y2, colour )
{
#	printf("  0\nLINE\n  8\ndefault\n  6\nDASHED\n 62\n%i\n",colour)
	printf("  0\nLINE\n  8\ndefault\n 62\n%i\n",colour)
	printf(" 10\n%f\n 20\n%f\n 11\n%f\n 21\n%f\n",x1,y1,x2,y2);
}


function dottedline(  x1, y1,  x2, y2, colour )
{
	printf("  0\nLINE\n  8\ndefault\n  6\nDASHED\n 62\n%i\n",colour)
#	printf("  0\nLINE\n  8\ndefault\n 62\n%i\n",colour)
	printf(" 10\n%f\n 20\n%f\n 11\n%f\n 21\n%f\n",x1,y1,x2,y2);
}

function point(  x1, y1,  x2, y2 )
{
	printf("  0\nPOINT\n  8\ndefault\n")
	printf(" 62\n    1\n 10\n%f\n 20\n%f\n",x1,y1);
}

# Start bottom left at X,Y with Angle, with the  string
function text(  x1, y1, angle, s1 )
{
	printf("  0\nTEXT\n  8\ndefault\n")
	printf(" 62\n    0\n 10\n%f\n 20\n%f\n",x1,y1);		# position left bottom
	printf(" 40\n 0.3\n  1\n%s\n",s1)
	printf(" 50\n%f\n",angle)
	printf("  7\nITALIC\n")
}

# Centred at X,Y with Angle, with the  string
function text_Centered(  x1, y1, angle, s1 )
{
	printf("  0\nTEXT\n  8\ndefault\n")
	printf(" 62\n    0\n 10\n%f\n 20\n%f\n",x1,y1);		# position left bottom
	printf(" 72\n    4\n 73\n 2\n 11\n%f\n 21\n%f\n",x1,y1)	# position central,central
	printf(" 40\n 0.3\n  1\n%s\n",s1)
	printf(" 50\n%f\n",angle)
	printf("  7\nITALIC\n")

}


function F_insert( x1,y1,name )
{
	printf("  0\nINSERT\n  8\ndefault\n  2\n%s\n",name)
	printf(" 10\n%f\n 20\n%f\n",x1,y1)
}


function F_header()
{ 
	printf( "  0\nSECTION\n  2\nHEADER\n  9\n")
	printf( "$INSBASE\n 10\n0.0000\n 20\n0.0000\n  9\n")
	printf( "$EXTMIN\n 10\n-2.8952\n 20\n-1.0144\n  9\n")
	printf( "$EXTMAX\n 10\n2.8952\n 20\n1.0144\n")
	printf( "  9\n$LIMMIN\n 10\n-2.8952\n 20\n-1.0144\n")
	printf( "  9\n$LIMMAX\n 10\n2.8952\n 20\n1.0144\n")
	printf( "  9\n$VIEWCTR\n 10\n0.0000\n 20\n0.0000\n")
	printf( "  9\n$VIEWSIZE\n 40\n6.000000\n")
	printf( "  9\n$TEXTSTYLE\n  7\nSTANDARD\n")
	printf( "  9\n$CLAYER\n  8\ndefault\n")
	printf( "  0\nENDSEC\n")

# Tables
printf("  0\nSECTION\n  2\nTABLES\n")
printf("  0\nTABLE\n")
printf("  2\nLTYPE\n 70\n4919900\n")
printf("  0\nLTYPE\n  2\nCONTINUOUS\n 70\n    64\n  3\nSolid line\n 72\n    65\n 73\n     0\n 40\n0.0\n")
printf("  0\nLTYPE\n  2\nDASHED\n 70\n    64\n  3\n__ __ __ __ __ __ __ __ __ __ __ __ __ __ __\n 72\n    65\n 73\n     2\n 40\n0.75\n 49\n0.5\n 49\n-0.25\n")
printf("  0\nLTYPE\n  2\nHIDDEN\n 70\n    64\n  3\n_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _\n 72\n    65\n 73\n     2\n 40\n0.375\n 49\n0.25\n 49\n-0.125\n")
printf("  0\nLTYPE\n  2\nCENTER\n 70\n    64\n  3\n____ _ ____ _ ____ _ ____ _ ____ _ ____ _ ____\n 72\n    65\n 73\n     4\n 40\n2.0\n 49\n1.25\n 49\n-0.25\n 49\n0.25\n 49\n-0.25\n")
printf("  0\nLTYPE\n  2\nPHANTOM\n 70\n    64\n  3\n_____ _ _ _____ _ _ _____ _ _ _____ _ _ ____\n 72\n    65\n 73\n     6\n 40\n2.5\n 49\n1.25\n 49\n-0.25\n 49\n0.25\n 49\n-0.25\n 49\n0.25\n 49\n-0.25\n")
printf("  0\nLTYPE\n  2\nDOT\n 70\n    64\n  3\n...............................................\n 72\n    65\n 73\n     2\n 40\n0.25\n 49\n0.0\n 49\n-0.25\n")
printf("  0\nENDTAB\n")
printf("  0\nTABLE\n")
printf("  2\nLAYER\n 70\n      1\n")
printf("  0\nLAYER\n  2\ndefault\n 70\n    64\n 62\n     7\n  6\nCONTINUOUS\n")
printf("  0\nENDTAB\n")
printf("  0\nTABLE\n  2\nSTYLE\n  0\nENDTAB\n")
printf("  0\nTABLE\n  2\nVIEW\n 70\n     0\n  0\nENDTAB\n")
printf("  0\nENDSEC\n")


######   Blocks - Predefined symbols ####################
printf("  0\nSECTION\n  2\nBLOCKS\n")
printf("  0\nBLOCK\n  8\ndefault\n  6\nCONTINUOUS\n 62\n  7\n")
	## Left Arrow
printf("  2\nlarrow\n 70\n    64\n")
printf(" 10\n0.0\n 20\n0.0\n")
printf("  0\nLINE\n  8\ndefault\n")
printf(" 10\n 0.0\n 20\n 0.0\n")
printf(" 11\n 0.0250\n 21\n 0.0250\n")
printf("  0\nLINE\n  8\ndefault\n")
printf(" 10\n 0.0\n 20\n 0.0\n")
printf(" 11\n 0.0250\n 21\n-0.0250\n")
printf("  0\n ENDBLK\n  8\ndefault\n  6\nCONTINUOUS\n 62\n   7\n")

printf(" 0\nENDSEC\n")				# end BLOCKS


### Now start the lines
printf("  0\nSECTION\n  2\nENTITIES\n")
# do drawing here
}

function F_end ()
{
printf("  0\nENDSEC\n")
printf("  0\nEOF\n")

}

